#define _GNU_SOURCE
#include <pthread.h>
#include <sched.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

void * fonction_thread(void * arg)
{
	int cpu = (int) arg;
	cpu_set_t cpu_set;
	int i;

	CPU_ZERO(& cpu_set);
	CPU_SET(cpu, & cpu_set);
	if (sched_setaffinity(0, sizeof(cpu_set), & cpu_set) != 0){
		perror("sched_setaffinity");
		exit(EXIT_FAILURE);
	}
	sleep(cpu); // Pour decaller les executions des threads d'une seconde
	while (1) {
		for (i = 0; i < 1000000000; i ++)
			;
		sleep(4);
	}
	return NULL;
}


int main(void)
{
	
	int cpu;
	pthread_t thr;
	for (cpu = 0; cpu < sysconf(_SC_NPROCESSORS_ONLN); cpu ++) {
		pthread_create(& thr, NULL, fonction_thread, (void *) cpu);
	}
	pthread_exit(NULL);
}

